<?php
/**
 * See docs/AUTHORS and docs/COPYRIGHT for relevant info.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * Foundation class that supports many repetitive functions.
 *
 * @version $Id$
 * @author Matthew McNaney <mcnaney at gmail dot com>
 * @package
 * @license http://opensource.org/licenses/lgpl-3.0.html
 */

abstract class Data {

    public function debug($hidden_values = null)
    {
        if (function_exists('xdebug_var_dump')) {
            // xdebug adds <pre> tags
            var_dump($this);
        } else {
            echo '<pre>';
            var_dump($this);
            echo '</pre>';
        }
    }

    public function firebug()
    {
        if (PHPWS_Settings::get('core', 'firephp_enabled')) {

            require_once('FirePHPCore/FirePHP.class.php');
            $firephp = FirePHP::getInstance(true);
            $options = array('maxObjectDepth' => 4,
                             'maxArrayDepth' => 10,
                             'useNativeJsonEncode' => true,
                             'includeLineNumbers' => true);
            $firephp->setOptions($options);
            $firephp->log($this, get_class($this));
        }
    }
}
?>